import geompy
import smesh

# Geom Creation
Vertex_1 = geompy.MakeVertex(0, 0, 0)
Vertex_2 = geompy.MakeVertex(2, 0, 0)
Vertex_3 = geompy.MakeVertex(2, 1, 0)
Vertex_4 = geompy.MakeVertex(1, 2, 0)
Vertex_5 = geompy.MakeVertex(0, 2, 0)
Line_1 = geompy.MakeLineTwoPnt(Vertex_1, Vertex_2)
Line_2 = geompy.MakeLineTwoPnt(Vertex_2, Vertex_3)
Line_3 = geompy.MakeLineTwoPnt(Vertex_3, Vertex_4)
Line_4 = geompy.MakeLineTwoPnt(Vertex_4, Vertex_5)
Line_5 = geompy.MakeLineTwoPnt(Vertex_5, Vertex_1)
Face_2 = geompy.MakeFaceWires([Line_1, Line_2, Line_3, Line_4, Line_5], 1)
[Edge_1,Edge_2,Edge_3,Edge_4,Edge_5] = geompy.SubShapeAllSorted(Face_2, geompy.ShapeType["EDGE"])
geomObj_1 = geompy.GetSubShape(Edge_2, [3])
Line_6 = geompy.MakeLineTwoPnt(Vertex_2, Vertex_5)
Vertex_6 = geompy.MakeVertexOnCurve(Line_6, 0.5)
Vertex_7 = geompy.MakeVertexOnCurve(Edge_4, 0.5)
Line_7 = geompy.MakeLineTwoPnt(Vertex_1, Vertex_6)
Line_8 = geompy.MakeLineTwoPnt(Vertex_6, Vertex_7)
Partition_1 = geompy.MakePartition([Face_2], [Line_6, Line_8], [], [], geompy.ShapeType["FACE"], 0, [], 0)
geompy.addToStudy( Vertex_1, "Vertex_1" )
geompy.addToStudy( Vertex_2, "Vertex_2" )
geompy.addToStudy( Vertex_3, "Vertex_3" )
geompy.addToStudy( Vertex_4, "Vertex_4" )
geompy.addToStudy( Vertex_5, "Vertex_5" )
geompy.addToStudy( Line_1, "Line_1" )
geompy.addToStudy( Line_2, "Line_2" )
geompy.addToStudy( Line_3, "Line_3" )
geompy.addToStudy( Line_4, "Line_4" )
geompy.addToStudy( Line_5, "Line_5" )
geompy.addToStudyInFather( Face_2, Edge_1, "Edge_1" )
geompy.addToStudyInFather( Face_2, Edge_2, "Edge_2" )
geompy.addToStudy( Face_2, "Face_2" )
geompy.addToStudyInFather( Face_2, Edge_3, "Edge_3" )
geompy.addToStudyInFather( Face_2, Edge_4, "Edge_4" )
geompy.addToStudyInFather( Face_2, Edge_5, "Edge_5" )
geompy.addToStudyInFather( Vertex_2, Line_6, "Line_6" )
geompy.addToStudy( Line_7, "Line_7" )
geompy.addToStudy( Line_8, "Line_8" )
geompy.addToStudy( Vertex_6, "Vertex_6" )
geompy.addToStudy( Partition_1, "Partition_1" )

[Edge_6,Edge_7,Edge_8,Edge_9,Edge_10,Edge_11,Edge_12,Edge_13,Edge_14] = geompy.SubShapeAllSorted(Partition_1, geompy.ShapeType["EDGE"])
geompy.addToStudyInFather( Partition_1, Edge_6, "Edge_6" )
geompy.addToStudyInFather( Partition_1, Edge_7, "Edge_7" )
geompy.addToStudyInFather( Partition_1, Edge_8, "Edge_8" )
geompy.addToStudy( Vertex_7, "Vertex_7" )
geompy.addToStudyInFather( Partition_1, Edge_9, "Edge_9" )
geompy.addToStudyInFather( Partition_1, Edge_10, "Edge_10" )
geompy.addToStudyInFather( Partition_1, Edge_11, "Edge_11" )
geompy.addToStudyInFather( Partition_1, Edge_12, "Edge_12" )
geompy.addToStudyInFather( Partition_1, Edge_13, "Edge_13" )
geompy.addToStudyInFather( Partition_1, Edge_14, "Edge_14" )

# Mesh creation
smeshGlobal = smesh.Mesh(Partition_1, "GlobalMesh")
smeshGlobal.Quadrangle()

A0_1_2_2_2_1 = smeshGlobal.Segment(Edge_7)
A0_1_2_2_2_1.NumberOfSegments(15)
A0_1_2_2_2_2 = smeshGlobal.Segment(Edge_8)
A0_1_2_2_2_2.NumberOfSegments(15)
A0_1_2_2_2_3 = smeshGlobal.Segment(Edge_9)
A0_1_2_2_2_3.NumberOfSegments(15)
A0_1_2_2_2_4 = smeshGlobal.Segment(Edge_10)
A0_1_2_2_2_4.NumberOfSegments(15)
A0_1_2_2_2_5 = smeshGlobal.Segment(Edge_11)
A0_1_2_2_2_5.NumberOfSegments(15)
A0_1_2_2_2_6 = smeshGlobal.Segment(Edge_12)
A0_1_2_2_2_6.NumberOfSegments(15)
A0_1_2_2_2_7 = smeshGlobal.Segment(Edge_13)
A0_1_2_2_2_7.NumberOfSegments(15)
A0_1_2_2_2_8 = smeshGlobal.Segment(Edge_14)
A0_1_2_2_2_8.NumberOfSegments(15)
A0_1_2_2_2_9 = smeshGlobal.Segment(Edge_6)
A0_1_2_2_2_9.NumberOfSegments(15)
smeshGlobal.Compute()
